"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tag = tag;
exports.declaration = declaration;
exports.serialize = serialize;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

function tag(name) {
  var children = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
  var attributes = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  return {
    name: name,
    children: children,
    attributes: attributes
  };
}

function declaration(attributes) {
  return {
    attributes: attributes
  };
}

var format_declaration = function format_declaration(attributes) {
  return "<?xml ".concat(attributes, "?>");
};

var format_attributes = function format_attributes(node) {
  return node.attributes.map(function (_ref) {
    var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
        key = _ref2[0],
        value = _ref2[1];

    return "".concat(key, "=\"").concat(value, "\"");
  }).join(" ");
};

var format_tag = function format_tag(name, attributes, content) {
  return "<".concat(name).concat(attributes.length > 0 ? " ".concat(attributes) : "", ">").concat(content, "</").concat(name, ">");
};

function serialize() {
  for (var _len = arguments.length, nodes = new Array(_len), _key = 0; _key < _len; _key++) {
    nodes[_key] = arguments[_key];
  }

  return nodes.map(function (node) {
    var attributes = format_attributes(node);

    if (node.hasOwnProperty("name")) {
      var tag1 = node;
      var children = get_children(node);
      return format_tag(node.name, attributes, children);
    } else {
      return format_declaration(attributes);
    }
  }).join("");
}

var get_children = function get_children(tag1) {
  return typeof tag1.children === "string" ? tag1.children : tag1.children.map(function (child) {
    return serialize(child);
  }).join("");
};
